#!/usr/bin/perl
# imp.mod.pl
# a dulog module
#
# $Id: imp.mod.pl,v 1.2 2001/09/06 20:11:04 icon Exp $
#

#get the files
#debugging - comment out turn off to act normally
#my $debug=1;

if (defined($debug)) {
 #get the files
 $logcat="$ARGV[0]";
 $report="$ARGV[1]";
} else {
 #get the files
 $logcat="$ENV{LOGCAT}";
 $report="$ENV{LOGREPORT}";
}


#open them :)
open(in, "$logcat");
@log=<in>;
close(in);
open(out, ">>$report");

my @failure;
my @success;
my @notimp;
foreach $line (@log) {
 if ($line =~ /IMP.*\:.*Login/) {
   push @success, $line;
 } elsif ($line =~ /IMP.*\:.*FAILED/) {
   push @failure, $line;
 } else {
  push @notimp, $line;
 }
}

#print out the type of logins that have occurred if any have occurred
if ((@failure) || (@success)) {
print out "\nIMP Activity\n---------------------\n";
  foreach my $login (@failure) {
    my ($remote,$local,$user) = ($login =~ m/.{15}\s.*\:\sFAILED\s(.*)\sto\s(.*)\sas\s(.*)/);
    print out "failed login by $user from " . &gethostdatabyaddr($remote) . " to $local\n";
  }
  foreach my $login (@success) {
   my ($remote,$local,$user) = ($login =~ m/.{15}\s.*\:\sLogin\s(.*)\sto\s(.*)\sas\s(.*)/);
    print out "login by $user from " . &gethostdatabyaddr($remote) . " to $local\n";
  }
}

close(out);

if(defined($ENV{WEED})) {
 open(logdone, ">$logcat");
 foreach $line (@notimp) {
  print logdone "$line";
 }
 close(logdone);
}


sub gethostdatabyaddr {
 #takes ip address as argument - returns name or whatever.
 my @inaddr=split(/\./, $_[0]); 
 my ($name, $aliases, $addrtype, $length, @addrs);

 ($name,$aliases,$addrtype,$length,@addrs) = gethostbyaddr((pack("C4","$inaddr[0]","$inaddr[1]","$inaddr[2]","$inaddr[3]"), 2));
 #if we've got nothing then return the ip
 if (defined($name)) {
  return ($name);
 } else {
  return ($_[0]);
 }
}
