#!/bin/bash
# logins.mod.sh
# A dulog module. Analyzes pam logins and outputs them in a nice format.
# I get a headache just trying to figure out what the hell I wrote here. :)
# by Icon Riabitsev <icon@phy.duke.edu>
#
# $Id: logins.mod.sh,v 1.4 2001/09/06 20:52:44 icon Exp $
#

braindamage(){
# my head hurts
# $1 is grep rule
# $2 is sed rule
if [ -s $WORKPREFIX.uhosts ]; then
 for LOGHOST in `egrep "$1" $WORKPREFIX.uhosts | sed "$2" | sort | uniq -c | awk '{print $2 "[" $1 "]"}'`; do
   echo -n " $LOGHOST" >> $WORKPREFIX.userlist
   #echo "HOSTSERV(PAM_): $HOSTSERV"
 done
 egrep -v "$1" $WORKPREFIX.uhosts > $WORKPREFIX.uhosts.new
 mv $WORKPREFIX.uhosts.new $WORKPREFIX.uhosts
fi
}

getuserlist() {
 # $1 should be the file with log entries
 rm -f $WORKPREFIX.userlist
 egrep " for user [[:alnum:]]" $1 > $1.new
 egrep "\-> [[:alnum:]]" $1 >> $1.new
 egrep " user=[[:alnum:]]" $1 >> $1.new
 for ENTRY in `sed "s/.* for user \([[:alnum:]]*\).*/\1/g; s/.*-> \([[:alnum:]]*\).*/\1/g; s/.* user=\([[:alnum:]]*\).*/\1/g" $1.new | sort | uniq`; do
  echo -n "$ENTRY ->" >> $WORKPREFIX.userlist
  egrep "[^[:alnum:]]*$ENTRY[^[:alnum:]]*" $1.new > $WORKPREFIX.uhosts
  braindamage "\(pam_unix\)" "s/.* [[:digit:]]*:[[:digit:]]*:[[:digit:]]* \([^[:space:]]*\) \(.*\)(pam_unix).*/\1:\2/g; s|.*/||g"
  braindamage "PAM_.*: \(.*\)" "s/.* [[:digit:]]*:[[:digit:]]*:[[:digit:]]* \([^[:space:]]*\) .*PAM_.*: (\([^[:space:]]*\)).*/\1:\2/g; s|.*/||g"
  #braindamage "PAM_.*:.*" "s/.* [[:digit:]]*:[[:digit:]]*:[[:digit:]]* \([^[:space:]]*\) .*PAM_.*: (\([^[:space:]]*\)).*/\1:\2/g; s|.*/||g"
  braindamage "*" "s/.* [[:digit:]]*:[[:digit:]]*:[[:digit:]]* \([^[:space:]]*\) .*/\1/g; s|.*/||g"
  echo >> $WORKPREFIX.userlist
 done
 rm -f $1.new
}

WORKPREFIX="$TMPPREFIX.logins"

# find all root logins, except the xscreensaver, which checks
# against root at any time, and messages coming from kernel:
egrep "[^[:alnum:]]*[Rr][Oo][Oo][Tt][^[:alnum:]]*" $LOGCAT | grep -v "xscreensaver" | grep -v "kernel: " | egrep "[Pp][Aa][Mm]" > $WORKPREFIX.root.all
if [ -s $WORKPREFIX.root.all ]; then
 echo -e "\nLOGINS\n-------\n::::ROOT logins::::" > $WORKPREFIX.report
 # first, Failed root logins
 egrep "[Ff]ail" $WORKPREFIX.root.all > $WORKPREFIX.root.fail
 # now, successful ones
 egrep -v "[Ff]ail" $WORKPREFIX.root.all > $WORKPREFIX.root.success
 if [ -s $WORKPREFIX.root.fail ]; then
  echo -e "\n::FAILED ROOT LOGINS::" >> $WORKPREFIX.report
  cat $WORKPREFIX.root.fail >> $WORKPREFIX.report
 fi
 if [ -s $WORKPREFIX.root.success ]; then
  echo -e "\n::Successfull ROOT logins::" >> $WORKPREFIX.report
  cat $WORKPREFIX.root.success >> $WORKPREFIX.report
 fi
fi

# find other logins
egrep "[Pp][Aa][Mm]_" $LOGCAT | egrep -v "[^[:alnum:]]*[Rr][Oo][Oo][Tt][^[:alnum:]]*" > $WORKPREFIX.user.all
if [ -s $WORKPREFIX.user.all ]; then
 echo -e "\n::::User logins::::" >> $WORKPREFIX.report
 # first, failed ones
 egrep "[Ff]ail" $WORKPREFIX.user.all > $WORKPREFIX.user.fail
 # now non-failed. ;)
 egrep -v "[Ff]ail" $WORKPREFIX.user.all > $WORKPREFIX.user.success
 if [ -s $WORKPREFIX.user.fail ]; then
  echo -e "\n::FAILED user logins::" >> $WORKPREFIX.report
  getuserlist $WORKPREFIX.user.fail
  if [ -s $WORKPREFIX.userlist ]; then
   cat $WORKPREFIX.userlist >> $WORKPREFIX.report
  fi
  echo -e "\n::Raw listing::" >> $WORKPREFIX.report
  cat $WORKPREFIX.user.fail >> $WORKPREFIX.report
 fi
 if [ -s $WORKPREFIX.user.success ]; then
  echo -e "\n::Successful user logins::" >> $WORKPREFIX.report
  getuserlist $WORKPREFIX.user.success
  if [ -s $WORKPREFIX.userlist ]; then
   cat $WORKPREFIX.userlist >> $WORKPREFIX.report
  fi
  echo -e "\n::Raw listing::" >> $WORKPREFIX.report
  cat $WORKPREFIX.user.success >> $WORKPREFIX.report
 fi
fi

if [ ! -z "$WEED" ]; then
 # weed out pam entries
 egrep -v "[Pp][Aa][Mm]_" $LOGCAT > $LOGCAT.new
 mv $LOGCAT.new $LOGCAT
fi

if [ -s $WORKPREFIX.report ]; then
 cat $WORKPREFIX.report >> $LOGREPORT
fi
